local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/iron_density.png", "IRON_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mapMod:registerAssetId("maps/tree_density_map1.png", "TREE_DENSITY_MAP1")
mapMod:registerAssetId("maps/tree_density_map2.png", "TREE_DENSITY_MAP2")
mapMod:registerAssetId("maps/tree_density_map3.png", "TREE_DENSITY_MAP3")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "GARMISCH_PARTENKIRCHEN_ID",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -3,
	MaxHeight = 180,
	VillagePathList = {
		{
			Entrance = { 700, 0, 1013 },
			Exit = { 10, 0, 423 },
		},
		{
			Entrance = { 900, 0, 1013 },
			Exit = { 1010, 0, 423 },
		},
		{
			Entrance = { 10, 0, 223 },
			Exit = { 700, 0, 13 },
		}
	},
	SpawnList = {
		},
	DensitySpawnList = {
			{
			-- creating Tree Density Map1
			DensityMap = "TREE_DENSITY_MAP1",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 5.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map2
			DensityMap = "TREE_DENSITY_MAP2",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_SYCAMORE" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.2,1 },
							Max = { 0.8,0.8,0.4,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_POPLAR" },
						RandomWeight = 1.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.8,0.8,0.8,1 },
							Max = { 1.0,1.0,1.0,1 }
					}
				}
			}
		},
			{
			-- creating Tree Density Map3
			DensityMap = "TREE_DENSITY_MAP3",
			Density = 0.8,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.0,0.5,1.0,1 },
							Max = { 0.5,0.75,1.0,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.2,1 },
							Max = { 0.8,0.8,0.4,1 }
					}
				},
				{
						PrefabList = { "PREFAB_TREE_PINE" },
						RandomWeight = 3.0,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.8,
							Max = 1.2
					},
						ColorRange = {
							Min = { 0.4,0.4,0.4,1 },
							Max = { 0.7,0.7,0.7,1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create iron deposits
			DensityMap = "IRON_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_IRON" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})
-- This map was created with the help of the UFME
